#
# Copyright (c) 2008-2015 Thierry Florac <tflorac AT ulthar.net>
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#

__docformat__ = 'restructuredtext'


# import standard library

# import interfaces

# import packages
from zope.interface import Interface
from zope.schema import Choice

from pyams_content_es import _


#
# Indexer interfaces
#

INDEXER_NAME = 'ElasticSearch content indexer'
INDEXER_HANDLER_KEY = 'pyams_content.es.tcp_handler'


#
# Utility interfaces
#

class IContentIndexerUtility(Interface):
    """Content indexer utility interface"""

    zeo_connection = Choice(title=_("ZEO connection name"),
                            description=_("Name of ZEO connection utility defining indexer connection"),
                            required=False,
                            vocabulary="PyAMS ZEO connections")

    def index_document(self, document):
        """Index given document"""

    def unindex_document(self, document):
        """Un-index given document"""

    def test_process(self):
        """Send test request to indexer process"""


#
# Contents interfaces
#

class IDocumentIndexInfo(Interface):
    """Document index info"""


class IDocumentIndexTarget(Interface):
    """Document index target marker interface"""
